package org.apache.bcel.generic;

import org.apache.bcel.ExceptionConst;
import org.apache.bcel.ExceptionConst.EXCS;

public class GETFIELD extends FieldInstruction implements ExceptionThrower, StackConsumer, StackProducer {
   GETFIELD() {
   }

   public GETFIELD(int index) {
      super((short)180, index);
   }

   public void accept(Visitor v) {
      v.visitExceptionThrower(this);
      v.visitStackConsumer(this);
      v.visitStackProducer(this);
      v.visitTypedInstruction(this);
      v.visitLoadClass(this);
      v.visitCPInstruction(this);
      v.visitFieldOrMethod(this);
      v.visitFieldInstruction(this);
      v.visitGETFIELD(this);
   }

   public Class<?>[] getExceptions() {
      return ExceptionConst.createExceptions(EXCS.EXCS_FIELD_AND_METHOD_RESOLUTION, new Class[]{ExceptionConst.NULL_POINTER_EXCEPTION, ExceptionConst.INCOMPATIBLE_CLASS_CHANGE_ERROR});
   }

   public int produceStack(ConstantPoolGen cpg) {
      return this.getFieldSize(cpg);
   }
}
